## net.sf.saxon.value
Class AnyURIValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.StringValue
                  net.sf.saxon.value.AnyURIValue

All Implemented Interfaces:
  Expression, Item, java.io.Serializable, ValueRepresentation

public final class AnyURIValue
extends StringValue

An XPath value of type xs:anyURI.

This is implemented as a subtype of StringValue even though xs:anyURI is not a subtype of xs:string in the XPath type hierarchy. This enables type promotion from URI to String to happen automatically in most cases where it is appropriate.

This implementation of xs:anyURI allows any string to be contained in the value space. It is possible to validate that the string is a "valid URI" in the sense of XML Schema Part 2 (which refers to the XLink specification and to RFC 2396); however, this validation is optional, and is not carried out by default. In particular, there is no constraint that namespace URIs, collation URIs, and the like should be valid URIs. However, casting from strings to xs:anyURI does invoke validation.

See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class net.sf.saxon.value.StringValue
`StringValue.CharacterIterator`

Field Summary
`static AnyURIValue` `EMPTY_URI`

Fields inherited from class net.sf.saxon.value.StringValue
`EMPTY_STRING, length, SINGLE_SPACE, value`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`AnyURIValue(java.lang.CharSequence value)` Constructor

Method Summary
`AtomicValue` `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`java.lang.Object` `convertToJava(java.lang.Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`boolean` `effectiveBooleanValue(XPathContext context)` Get the effective boolean value of the value
`boolean` `equals(java.lang.Object other)` Determine if two AnyURIValues are equal, according to XML Schema rules.
`ItemType` `getItemType(TypeHierarchy th)` Return the type of the expression
`static boolean` `isValidURI(java.lang.CharSequence value)` Check whether a string consititutes a valid URI

Methods inherited from class net.sf.saxon.value.StringValue
`contract, convertStringToAtomicType, convertStringToBuiltInType, expand, getStringLength, getStringLength, getStringValue, getStringValueCS, hashCode, iterateCharacters, makeStringValue, schemaEquals, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, display, evaluateAsString, evaluateItem, getCardinality, getComponent, getImplementationMethod, getLength, getPrimitiveValue, getTypedValue, hasBuiltInType, iterate, process`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, collapseWhitespace, convert, convertJavaObjectToXPath, getDependencies, getIterator, getParentExpression, getSpecialProperties, itemAt, iterateSubExpressions, makeQNameValue, normalizeWhitespace, optimize, promote, reduce, simplify, stringToNumber, trimWhitespace, typeCheck`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### EMPTY_URI

    public static final AnyURIValue EMPTY_URI

Constructor Detail

### AnyURIValue

    public AnyURIValue(java.lang.CharSequence value)

  Constructor

Parameters:
  `value` - the String value. Null is taken as equivalent to "".

Method Detail

### isValidURI

    public static boolean isValidURI(java.lang.CharSequence value)

  Check whether a string consititutes a valid URI

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Overrides:
    `convertPrimitive` in class `StringValue`
  Parameters:
    `requiredType` - integer code representing the item type required
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    the result of the conversion, or an ErrorValue

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Return the type of the expression

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `StringValue`
  Parameters:
    `th` -
  Returns:
    Type.ANY_URI_TYPE (always)

### equals

    public boolean equals(java.lang.Object other)

  Determine if two AnyURIValues are equal, according to XML Schema rules. (This method is not used for XPath comparisons, which are always under the control of a collation.)

  Overrides:
    `equals` in class `StringValue`
  Throws:
    `java.lang.ClassCastException` - if the values are not comparable

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)
                                  throws XPathException

  Get the effective boolean value of the value

  Specified by:
    `effectiveBooleanValue` in interface `Expression`
  Overrides:
    `effectiveBooleanValue` in class `StringValue`
  Parameters:
    `context` - the evaluation context (not used in this implementation)
  Returns:
    true, unless the value is boolean false, numeric zero, or zero-length string
  Throws:
    `XPathException`

### convertToJava

    public java.lang.Object convertToJava(java.lang.Class target,
                                          XPathContext context)
                                   throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `StringValue`
  Parameters:
    `target` - the Java class to which conversion is required
  Returns:
    the result of the conversion
  Throws:
    `XPathException` - if conversion to this target type is not possible